!-------------------------------------------------
!interface module of odelib
!-------------------------------------------------
module ode_interface
  interface
!----------------------------------------------------------------------
!ASY[`
    subroutine odrkg(n,fcn,t,dt,x,dx,xout,work)   !Q-Nb^-M
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(in) :: dt                 !ϕXebv.
      real,      intent(in), dimension(n) :: x    !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: dx !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: xout !ϕϐt=t+dtɂl
      real,      intent(out), dimension(n) :: work !ƕϐ
    end subroutine
      
    subroutine odrk4(n,fcn,t,dt,x,dx,xout,work)   !4x̃Q-Nb^
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(in) :: dt                 !ϕXebv
      real,      intent(in), dimension(n) :: x    !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: dx !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: xout !ϕϐt=t+dtɂl
      real,      intent(out), dimension(n,3) :: work !ƕϐ
    end subroutine
      
    subroutine odrk2(n,fcn,t,dt,x,dx,xout,work)   !2x̃Q-Nb^
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(in) :: dt                 !ϕXebv
      real,      intent(in), dimension(n) :: x    !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: dx !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: xout !ϕϐt=t+dtɂl
      real,      intent(out), dimension(n) :: work !ƕϐ
    end subroutine
      
    subroutine odrk1(n,fcn,t,dt,x,dx,xout,work)   !1x̃Q-Nb^łD
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(in) :: dt                 !ϕXebv
      real,      intent(in), dimension(n) :: x    !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: dx !ϕϐt=t ɂl
      real,      intent(inout), dimension(n) :: xout !ϕϐt=t+dtɂl
      real,      intent(out), dimension(n) :: work !ƕϐ
    end subroutine
!--------------------------------------------------------------------
!Xebp[`
    subroutine odrkgr(n,fcn,t,dt,epsl,x,work)     !ϕ݂̂߂
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(inout) :: dt              !ϕXebv
      real,      intent(in) :: epsl               !vx
      real,      intent(inout), dimension(n) :: x !ϕϐt=t ɂl͂,t=t+ 2 ɂl o͂D
      real,      intent(out), dimension(n,5) :: work !ƕϐ
    end subroutine
      
    subroutine odrkgs(n,fcn,t,dt,epsl,x,work)     !Œ蕝݂̂߂D
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(inout) :: dt              !ϕXebv
      real,      intent(in) :: epsl               !vx
      real,      intent(inout), dimension(n) :: x !ϕϐt=t ɂl͂,t=t+ 2 ɂl o͂
      real,      intent(out), dimension(n,3) :: work !ƕϐ
    end subroutine
      
    subroutine odrk4r(n,fcn,t,dt,epsl,x,work)     !ϕ݂̂߂D
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(inout) :: dt              !ϕXebv
      real,      intent(in) :: epsl               !vx
      real,      intent(inout), dimension(n) :: x !ϕϐt=t ɂl͂,t=t+ 2 ɂl o͂
      real,      intent(out), dimension(n,7) :: work !ƕϐ
    end subroutine
      
    subroutine odrk4s(n,fcn,t,dt,epsl,x,work)     !Œ蕝݂̂߂D  
      integer,   intent(in) :: n                  !ϕϐij̐
      external  fcn                                !dxvZTu[`
      real,      intent(in) :: t                  !Ɨϐt̒l
      real,      intent(inout) :: dt              !ϕXebv
      real,      intent(in) :: epsl               !vx
      real,      intent(inout), dimension(n) :: x !ϕϐt=t ɂl͂,t=t+ 2 ɂl o͂
      real,      intent(out), dimension(n,5) :: work !ƕϐ
    end subroutine
!-----------------------------------------------------------------
!hCo[` 
    subroutine odrkdu(n,algor,fcn,t,tend,istep,x,work) !Œ荏ŐϕsD   
      integer,   intent(in) :: n                  !ϕϐij̐
      external  algor                              !gpASY[`
      external  fcn                                !dxvZTu[`
      real,      intent(inout) :: t               !ϕn߂Ɨϐt̒lD
      real,      intent(in) :: tend               !ϕIƗϐt̒l
      integer,   intent(in) :: istep              !XebvD
      real,      intent(inout), dimension(n) :: x !ϕϐt=tɂl͂C t=tendɂlo͂D
      real,      intent(out), dimension(n,*) :: work !ƕϐ
    end subroutine
      
    subroutine odrkdv(n,steper,fcn,t,tint,dt,x,work) !vx𖞂悤ɐϕsD
      integer,   intent(in) :: n                  !ϕϐij̐
      external  steper                             !gpASY[`
      external  fcn                                !dxvZTu[`
      real,      intent(inout) :: t               !ϕn߂Ɨϐt̒l
      real,      intent(in) :: tint               !ϕIƗϐt̒l
      real,      intent(inout) :: dt              !Xebv̏l
      real,      intent(inout), dimension(n) :: x !ϕϐt=tɂl͂C t=tendɂlo͂D
      real,      intent(out), dimension(n,*) :: work !ƕϐ
    end subroutine
!--------------------------------------------------------------------
!ϐǗ[`
    subroutine odpget(cpara,ipara)                !odrkdv ŎgpϐQƂD
      character(len=8), intent(in) :: cpara       !ϐ̖O
      integer,   intent(out) :: ipara             !ϐ̒l
    end subroutine
      
    subroutine odiget(cpara,ipara)                !odrkdv ŎgpϐQƂD
      character(len=8), intent(in) :: cpara       !ϐ̖O
      integer,   intent(out) :: ipara             !ϐ̒l
    end subroutine
      
    subroutine odrget(cpara,ipara)                !odrkdv ŎgpϐQƂD
      character(len=8), intent(in) :: cpara       !ϐ̖O
      real,      intent(out) :: ipara             !ϐ̒l
    end subroutine
      
    subroutine odlget(cpara,ipara)                !odrkdv ŎgpϐQƂD
      character(len=8), intent(in) :: cpara       !ϐ̖O
      logical,   intent(out) :: ipara             !ϐ̒l
    end subroutine
      
    subroutine odpset(cpara,ipara)                !odrkdv Ŏgpϐݒ肷D
      character(len=8), intent(in) :: cpara       !ϐ̖O
      integer,   intent(in) :: ipara              !ϐ̒l
    end subroutine
      
    subroutine odiset(cpara,ipara)                !odrkdv Ŏgpϐݒ肷D
      character(len=8), intent(in) :: cpara       !ϐ̖O
      integer,   intent(in) :: ipara              !ϐ̒l
    end subroutine
      
    subroutine odrset(cpara,ipara)                !odrkdv Ŏgpϐݒ肷D
      character(len=8), intent(in) :: cpara       !ϐ̖O
      real,      intent(in) :: ipara              !ϐ̒l
    end subroutine
      
    subroutine odlset(cpara,ipara)                !odrkdv Ŏgpϐݒ肷D
      character(len=8), intent(in) :: cpara       !ϐ̖O
      logical,   intent(in) :: ipara              !ϐ̒l
    end subroutine

  end interface
end module
!odelib library end ----
